/*
   Bahti i zada4ata
*/
#include <iostream>
using namespace std;

int pr(int p)
{
   int i,flag=0,d1,d2;
   if(p==1)
   {
      return 1;
   }
   else
   {
      for(i=2;i*i<=p;i++)
      {
         if(p%i==0)
         {
            flag=1;
            break;
         }
      }
      if(flag==1)
      {
         return 1;
      }
      else
      {
         for(i=2;i*i<=p;i++)
         {
            if(p%i==0)
            {
               d1=i;
               d2=p/i;
               break;
            }
         }
         d1*=d2;
         return pr(d1);
      }
   }
}

int n,k;
int main()
{
   int i,s;
   cin>>n>>k;
   n=s;
   for(i=1;i<k;i++)
   {
      s=pr(s);
   }
   cout<<s;
   return 0;
}
